<?php


/* preg_match('/(\w+) just sent you a message from your marketplace profile/',$body,$matches);
	$username = $matches[1]; */


class envato{

	public $username;
	public $password;
	public $logged_in;
	public $statement_url;
	public $portfolio_url;
	public $profile_url;
	public $account_balance;
	public $cache_timeout;
	public $base_url;
	public $url_hits;
	public $url_size;
	public $items;
	public $cache_hit;
	public $item_comments;

	private $ch; // curl objecct
	private $postfix; // append this to all urls so provider can roughly track access.
	private $temp_cookie_file;
	private $cookie_file;
	private $marketplaces;
	private $time_offset;
	public $init_complete;

	/**
	 * Init function called by the master template manager.
	 * This usually just inits a session with the template provider.
	 * or reopens an existing session.
	 * Using curl and a temp file within /tmp/ to save session state.
	 *
	 */
	public function init() {

		if($this->init_complete){
			return true;
		}

		$this->account_balance = 0;
		$this->cache_hit = 0;
		$this->url_hits = 0;
		$this->url_size = 0;
		$this->logged_in = false;
		$this->cache_timeout = 1800;
		$this->item_comments = array();

        $this->cookie_file = _TMP_DIR.basename($this->username).'_cookie-file.txt';


		// list of all supported marketplaces.
		// they all have the same format profile woo!   i <3 u guys
		$this->marketplaces = array(
			"http://codecanyon.net",
			"http://themeforest.net",
			"http://activeden.net",
            "http://audiojungle.net",
            "http://videohive.net",
			"http://graphicriver.net",
			"http://3docean.net",
		);

		$this->base_url = $this->read_setting("base_url","http://themeforest.net");
		$this->statement_url = "/user/".$this->username."/download_statement_as_csv";
		$this->portfolio_url = "/user/".$this->username."/portfolio";
		$this->profile_url = "/user/".$this->username;

		// append this to all url calls so that themeforest can track us if they want? * shrug * just an idea.
		$this->postfix = "davestats";


		$time_difference = $this->read_setting("time_difference","+10");
		$this->time_offset = strtotime( $time_difference . " hours",0);

		// now we check the login status
		$res = $this->_check_login();
		if($res){
			$this->init_complete = true;
		}
		return $res;
	}

	/**
	 * This method handles all the remote URL gets, and caching.
	 *
	 * @param string $url Url to get: eg http://themeforest.net/user/dtbaker
	 * @param array $post Any post data to send (eg: login details)
	 * @param bool $force Force it to refresh, aka: dont read from cache.
	 * @return string  HTML data that came back from request.
	 */
	public function get_url($url,$post=array(),$force=false){

		$cache_key = md5($_SERVER['HTTP_HOST'] . $url . $this->username . serialize($post));

		if($this->logged_in/* ||
			(
				isset($_SESSION['_envato_loggedin_as']) &&
				isset($_SESSION['_envato_loggedin_as'][$this->username]) &&
				$_SESSION['_envato_loggedin_as'][$this->username]
			)*/
		){
			$data = ($force) ? false : $this->get_cache($cache_key);
		}


		// look at adding this later:
		// $url .= ((!strpos($url,'?')) ? '?' : '&') . $this->postfix;

		if(!isset($data) || !$data){
			if(!$this->ch){
				$this->ch = curl_init();
		        curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, true);
		        curl_setopt($this->ch, CURLOPT_FOLLOWLOCATION, true);
		        curl_setopt($this->ch, CURLOPT_CONNECTTIMEOUT, 3);
		        curl_setopt($this->ch, CURLOPT_TIMEOUT, 10);
		        curl_setopt($this->ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible;)");
		        curl_setopt($this->ch, CURLOPT_HEADER, 0);
			}

			// read the cookies out of the database, into a temp file, and pass that file to curl.
			// i tried to get funky and manually read the cookies in from the curl response headers
			// but i think my brain exploded a little.
			if(!is_dir(_TMP_DIR) || !is_writable(_TMP_DIR)){
				echo "The folder "._TMP_DIR." needs to be writable. <br><br>";
				echo "Please set the permissions on this folder to 'writable', you can do this using your favorite FTP program (right click this folder, set permissions, tick all writable)<br><br>";
				return false;
			}
			// only do cookies when logged in.

            if(_DEBUG_MODE){
                echo "Using cookie fix hack: Storing cookies in ".$this->cookie_file ."<br>";
            }
            if(!is_file($this->cookie_file)){
                touch($this->cookie_file);
            }
            curl_setopt($this->ch, CURLOPT_COOKIEJAR, $this->cookie_file);
            curl_setopt($this->ch, CURLOPT_COOKIEFILE, $this->cookie_file);



			curl_setopt($this->ch, CURLOPT_URL, $url);

			if($post){
	        	curl_setopt($this->ch, CURLOPT_POST, true);
	        	curl_setopt($this->ch, CURLOPT_POSTFIELDS, $post);
			}else{
	        	curl_setopt($this->ch, CURLOPT_POST, false);
	        	curl_setopt($this->ch, CURLOPT_POSTFIELDS, false);
			}

            $data = curl_exec($this->ch);

	        if(_DEBUG_MODE){
	            file_put_contents(_TMP_DIR."request-".$this->url_hits.".html",$data);
	            echo "Saved log file of '$url' to: "._TMP_DIR."request-".$this->url_hits.".html <br>";
	        }

        	//echo "$url <hr>br>".htmlspecialchars($data)."<hr>";
            $this->url_hits++;
            $this->url_size += curl_getinfo($this->ch, CURLINFO_SIZE_DOWNLOAD);


         	// we dont want to save a page that has "log in" on it.
         	if(!preg_match("#login/authenticate#",$data)){
            	$this->save_cache($cache_key,$data);
         	}

		}


		return $data;

	}

	public function shutdown(){
		// just a basic cleanup function
		if($this->ch){
			curl_close($this->ch);
		}
	}

	/**
	 * Grunt work for checking if the user is authenticated with
	 * ThemeForest and (if not) log them in using provided credentials.
	 *
	 * @param unknown_type $try_number
	 * @param unknown_type $data
	 * @return unknown
	 */
	private function _check_login($try_number=0,$data=false){

		if(!$data){
			$data = $this->_clean($this->get_url($this->base_url,array(),true));
		}
		// check if we are logged in or not.
        // simply look for the string logout and Log Out
        if($try_number>1){
        	//echo $this->base_url . $data;
        	 // TODO: handle if themeforest is down better?
        	echo "Unable to access ThemeForest. Sorry, please try again shortly.";
        	return false;
        }else if(preg_match('#signin/signout#',$data)){
        	$this->logged_in = true;
        }else if($this->username && $this->password){
        	$post_data = array(
        		"username"=>$this->username,
        		"password"=>$this->password,
        		"from_header_bar"=>"true",
        	);
	        if(_DEBUG_MODE){
        		echo "Login attempt $try_number with username: ".$this->username." <br> ";
	        }
        	$url = $this->base_url."/signin/authenticate";
        	$data = $this->get_url($url,$post_data,true);
	        if(_DEBUG_MODE){
	        	file_put_contents(_TMP_DIR."login-".$try_number.".html",$data);
	            echo "Saved LOGIN ATTEMPT file at: "._TMP_DIR."login-".$try_number.".html <br>";
	        }
            return $this->_check_login($try_number+1,$data);
        }else {
        	// no username or password, set, return false so we prompt them to login.
        	return false;
        }

        // $data now contains our home page in logged in version.
        // how much cash do we have?
        //<span class="user_balance">$4,829.40</span>
        if(preg_match('#class="user_balance">\$([^<]+)<#',$data,$matches)){
        	$this->account_balance = preg_replace('/[^\.\d]/','',$matches[1]);
        }
        return $this->logged_in;
	}

	public function logout(){
		// kill cookies
		$this->temp_cookie_file =false;
	}

	/**
	 * This pulls back list of allllll user items across all marketplaces.
	 *
	 * @return unknown
	 */
	public function get_my_items(){
		$this->items=array();
		$used_marketplaces = $this->marketplaces;
		if($this->username){
			$page_number = 1;
			$feed_data = $this->get_url($this->base_url . $this->portfolio_url . "?page=$page_number");

			foreach($used_marketplaces as $marketplace_id => $marketplace_url){
				if($this->base_url == $marketplace_url && !preg_match('#<h3 class="long-title">#',$feed_data)){

				}else if($this->base_url == $marketplace_url){
					continue;
				}
				// check if this one is linked anywhere.
				if(!preg_match('#'. preg_quote($marketplace_url.$this->portfolio_url,'#') . '#',$feed_data)){
					if(_DEBUG_MODE){
						echo 'The user doesn\'t have any items on '.$marketplace_url.'. <br>';
					}
					unset($used_marketplaces[$marketplace_id]);
				}
			}
			if(_DEBUG_MODE){
				echo 'The user has items on the following marketplaces: <br>';
				print_r($used_marketplaces);
			}
			foreach($used_marketplaces as $marketplace_url){
				$page_number = 1;
				$item_count = 0;
				while(true){
					// dub call to above, will be cached so not worried.
					$feed_data = $this->get_url($marketplace_url . $this->portfolio_url . "?page=$page_number");
					//<h3 class="long-title"><a href="http://flashden.net/item/xml-banner-rotator-7/59178">XML Banner Rotator 7</a></h3>
					if(preg_match_all('#<h3 class="long-title"><a href="([^"]+)">([^<]+)</a></h3>#U',$feed_data,$matches) ){
						foreach($matches[1] as $match_id => $url){
							if(preg_match('#/(\d+)$#',$url,$match_item_id)){
								$this->items[$match_item_id[1]] = array(
									"name"=>html_entity_decode($matches[2][$match_id]),
									"url"=> (preg_match('/^http/',$url)) ? $url : $this->base_url . $url,
									"id"=>$match_item_id[1],
									"marketplace"=>str_replace('http://','',str_replace('.net','',$marketplace_url)),
								);
								$item_count++;
							}
						}
					}
					//print_r($this->items);exit;
					if(_DEBUG_MODE){
						echo "Found $item_count items on $marketplace_url from page $page_number<br>";
					}
					$page_number++;
					if(!preg_match('/portfolio\?page='.$page_number.'/',$feed_data)){
						break;
					}
					if(_DEBUG_MODE){
						echo "Trying to read page $page_number of profile items.. <br>";
					}
				}
				if(_DEBUG_MODE){
					echo "Finished searching $marketplace_url for users items, found $item_count items.<br>";
				}
			}

		}
		return $this->items;
	}

	public function get_statement(){


		// we always grab a new copy of the latest months statement:
		// any previous months we always use the cached version:

		// get current statement:
		$data = $this->get_url($this->base_url . $this->statement_url,array(),true);
		if(preg_match('#<html#',$data)){
			if(!$this->_check_login()){
				echo 'fail';
				exit;
			}
		}
		// save as temp file and use fgetcsv
		// dont want to use str_getcsv because it requires 5.3 and im still on 5.2.
		$temp_csv_file = _TMP_DIR.basename($this->username)."_statement-csv-current.csv";
		file_put_contents($temp_csv_file,$data);

		$items = array();
		$months_ago = 1;
		$break_next = false;
		while(true){

			// reverse the loop up a bit, start with the temp csv from above. and then loop
			if($temp_csv_file && is_file($temp_csv_file)){
				$fd = fopen($temp_csv_file,"r");
				$count = 1;
				while (($data = fgetcsv($fd, 1000, ",")) !== FALSE) {
					if(1 == $count){
                        $count++;
                        continue;
                    } // dont save header.
					if(count($data)<2)continue;
					$items[]=$data;
					$count++;
				}
				if(_DEBUG_MODE){
					echo "Month: $temp_csv_file got $count items<br>";
				}
				fclose($fd);
			}
			// now we find all previous months until we hit a 404.
			// build the url for the previous month.
			// http://themeforest.net/user/dtbaker/download_statement_as_csv?month=5&year=2009
			$year = date("Y",strtotime("-$months_ago months",mktime(12,0,0,date("n"),15,date("Y"))));
			$month = date("n",strtotime("-$months_ago months",mktime(12,0,0,date("n"),15,date("Y"))));
			if($year <= $this->read_setting('year_stop',date("Y",strtotime('-1 years'))) && $month <= $this->read_setting('month_stop',date("n"))){
				break;
			}
			//$month_subtract = $months_ago % 12; //date("n",strtotime("-" . ($months_ago*30.5) . " days"));
			//$month = date("n") - $month_subtract;
			//if($month <= 0)$month = 12 + $month;
			// see if this file exist already.
			$temp_csv_file = _TMP_DIR.basename($this->username)."_statement-csv--m{$month}y{$year}.csv";
			//echo $temp_csv_file."<br>";
			if(!is_file($temp_csv_file)){
				// we've found the limit..
				$data = $this->get_url($this->base_url . $this->statement_url . '?month=' . $month . '&year=' . $year);
				//echo $this->base_url . $this->statement_url . '?month=' . $month . '&year=' . $year . "<br>";
				//if(!preg_match('#month='.$month.'&amp;year='.$year.'">download your statement#',$data)){
				if(preg_match('#<html#i',$data) && preg_match('#<body#i',$data)){
					// we've hit a 404 - time to break.

					$data = 'END_OF_STATEMENTS';
				}
				//echo strlen($data). "<br>";
				file_put_contents($temp_csv_file,$data);
			}

			// check if this one is blank - ie, the end of our loop
			// so we dont hit the 404 on every page load.
			$data = file_get_contents($temp_csv_file);
			if($data == 'END_OF_STATEMENTS'){

				//echo "<br>Breaking on $break_next - currently $months_ago <br>";

				if($break_next == $months_ago){
					break; // quick hack to do two months.
				}else{
					$break_next=$months_ago+1;
				}
			}

			$months_ago++;
		}

		//exit;
		//
		foreach($items as &$foo){

			$item_name = str_replace('"','',$foo[2]);

            $item_type = str_replace('"','',trim($foo[1]));
            $item_amount = 0;
            $item_rate = 0;
            $earnt = str_replace('"','',$foo[3]);
            if($item_type == 'sale'){
                // support the old method of logging stuff:
                if(preg_match('/sold (.*) for (\d.*) w\/ rate of (.*)%/U',str_replace('"','',$foo[3]),$matches)){
                    $item_name = $matches[1];
                    $item_amount = $matches[2];
                    $item_rate = $matches[3];
                    $earnt = str_replace('"','',$foo[2]);
                }else{
                    $item_name = $foo[2];
                    $item_amount = $foo[5];
                    $item_rate = str_replace('%','',$foo[4]);
                    $earnt = str_replace('"','',$foo[3]);
                }

            }

			$line = array(
				"type" => $item_type,
				"date" => trim($foo[0]),
				"time" => strtotime(trim($foo[0])),
				"item" => $item_name,
				"earnt" => $earnt,
				"amount" => $item_amount,
				"rate" => $item_rate,
			);
            $foo = $line;
		}
		if(_DEBUG_MODE){
			echo "There are ".count($items)." lines in your statement CSV file. Is this correct? <br>";
		}
        return $items;
	}


	public function read_setting($key,$default='',$db=false,$force=false){
		return get_option('ticket_entao_'.$key,$default);
	}

	// shift everything onto 1 line for easier regexing.
	private function _clean($data){
        $data = preg_replace("/\r|\n/","",$data);
        $data = preg_replace("/\s+/"," ",$data);
        return $data;
    }

    private function save_cache($key,$data){
        file_put_contents(_TMP_DIR.'cache-'.md5($key),$data);
    }
    private function get_cache($key){
        $file = _TMP_DIR.'cache-'.md5($key);
        if(is_file($file)){
            return file_get_contents($file);
        }else{
            return false;
        }
    }

}
