<?php


require_once('rfc822_addresses.php');
require_once('mime_parser.php');

// find all the mail setting accounts to check.

    $email_username = $account['username'];
    $email_password = $account['password'];
    $email_host = $account['host'];
    $email_port = $account['port'];
    $reply_from_user_id = $account['default_user_id'];
    $support_type = $account['default_type'];
    $subject_regex = $account['subject_regex'];
    $body_regex = $account['body_regex'];
    $to_regex = $account['to_regex'];
    $start_date = ($account['start_date'] && $account['start_date'] != '0000-00-00') ? strtotime($account['start_date']) : false;


    if(!$email_host || !$email_username){
        $status = false;
        return false;
    }

    $mbox = imap_open ('{'.$email_host.':'.$email_port.'/pop3/novalidate-cert}INBOX', $email_username, $email_password);
    imap_errors();
    if(!$mbox){
        // todo: send email letting them know bounce checking failed?
        echo 'Failed to connect to POP3 account. '.imap_last_error().' <br>';
        $status = false;
        return false;
    }else{

        wpetss_update_insert('ticket_account_id',$account['ticket_account_id'],'wpetss_ticket_account',array(
                                             'last_checked' => time(),
                                         ));

        $MC = imap_check($mbox);
        //echo 'Connected'.$MC->Nmsgs;
        $result = imap_fetch_overview($mbox,"1:{$MC->Nmsgs}",0);
        //print_r($result);
        foreach ($result as $overview) {
            if(!isset($overview->subject))continue;
            $message_id = isset($overview->message_id) ? (string)$overview->message_id : false;
            $this_subject = (string)$overview->subject;
            if(!$message_id){
                $message_id = md5($this_subject . $overview->date);
            }

            if($subject_regex && !preg_match($subject_regex,$this_subject)){
                continue;
            }

            if($start_date > 1000){
                if(strtotime($overview->date) < $start_date){
                    continue;
                }
            }

            //echo "#{$overview->msgno} ({$overview->date}) - From: {$overview->from} <br> {$this_subject} <br>\n";
            // check this email hasn't been processed before.
            // check this message hasn't been processed yet.
            $ticket = wpetss_get_single('wpetss_ticket_message','message_id',$message_id);
            if($ticket){
                continue;
            }

            $tmp_file = tempnam(_TMP_DIR,'ticket');
            imap_savebody  ($mbox, $tmp_file, $overview->msgno);
            $mail_content = file_get_contents($tmp_file);

            if($body_regex && !preg_match($body_regex,$mail_content)){
                continue;
            }

            $mime=new mime_parser_class();
            $mime->mbox = 0;
            $mime->decode_bodies = 1;
            $mime->ignore_syntax_errors = 1;
            $parameters=array(
                //'File'=>$mailfile,
                'Data'=>$mail_content,
                //'SaveBody'=>'/tmp',
                //'SkipBody'=>0,
            );

            $parse_success = false;
            if(!$mime->Decode($parameters, $decoded)){
                echo 'MIME message decoding error: '.$mime->error.' at position '.$mime->error_position."\n";
                // TODO - send warning email to admin.
                $parse_success = false;
            }else{
                for($message = 0; $message < count($decoded); $message++){
                    if($mime->Analyze($decoded[$message], $results)){

                        $from_address = $results['From'][0]['address'];

                        if($to_regex){
                            $to_match = false;
                            foreach($results['To'] as $possible_to_address){
                                if(preg_match($to_regex,$possible_to_address['address'])){
                                    $to_match = true;
                                }
                            }
                            if(!$to_match){
                                continue;
                            }
                        }

                        // find out which accout this sender is from.
                        if(preg_match('/@(.*)$/',$from_address,$matches)){



                            // run a hook now to parse the from address.

                            
                            $domain = $matches[1];

                            // find this sender in the database.
                            // if we cant find this sender/customer in the database
                            // then we add this customer as a "support user" to the default customer for this ticketing system.
                            // based on the "to" address of this message.



                            //store this as an eamil
                            $email_to = '';
                            $email_to_first = current($results['To']);
                            if($email_to_first){
                                $email_to = $email_to_first['address'];
                            }

                            // work out the from and to users.
                            $from_user_id = 0; // this becomes the "user_id" field in the ticket table.
                            $to_user_id = 0; // this is admin. leave blank for now i guess.
                            // try to find a user based on this from email address.

                            $from_user_id = module_ticket::user_from_email($from_address,$results['From'][0]['name']);
                            if(!$from_user_id){
                                continue;
                            }
                            $from_user = module_ticket::get_user($from_user_id);
                            

                            $ticket_id = false;
                            $new_message = true;
                            // check if the subject matches an existing ticket subject.
                            if(preg_match('#\[TICKET:(\d+)\]#i',$this_subject,$subject_matches)){
                                // found an existing ticket.
                                // find this ticket in the system.
                                $ticket_id = ltrim($subject_matches[1],'0');
                                // see if it exists.
                                $existing_ticket = wpetss_get_single('wpetss_ticket','ticket_id',$ticket_id);
                                if($existing_ticket){
                                    // woot!
                                    // todo - check the from/to email address is correct as well.
                                    // meh.
                                    wpetss_update_insert('ticket_id',$ticket_id,'wpetss_ticket',array(
                                                  'status_id' => 5,// change status to in progress.
                                                  'last_message_timestamp' => strtotime($overview->date),
                                               ));
                                    $new_message = false;
                                }else{
                                    // fail..
                                    $ticket_id = false;
                                }
                            }


                            if(!$ticket_id){
                                $ticket_id = wpetss_update_insert('ticket_id','new','wpetss_ticket',array(
                                                  'subject' => $this_subject,
                                                  'ticket_account_id' => $account['ticket_account_id'],
                                                  'status_id' => 2, // new !
                                                  'user_id' => $from_user_id,
                                                  'assigned_user_id'=>$reply_from_user_id,
                                                  'customer_id' => $from_user['customer_id'],
                                                  'type' => $support_type,
                                                  'last_message_timestamp' => strtotime($overview->date),
                                               ));
                            }

                            if(!$ticket_id){
                                echo 'Error creating ticket';
                                continue;
                            }
                            module_ticket::mark_as_unread($ticket_id);

                            $cache = array(
                                'from_email' =>  $from_address,
                                'to_email' => $email_to,
                            );

                            $ticket_data = module_ticket::get_ticket($ticket_id);
                            if(isset($ticket_data['assigned_user_id'])){
                                $to_user_id = $ticket_data['assigned_user_id'];
                            }

                            // pull otu the email bodyu.
                            $body = $results['Data'];
                            if($results['Type']=="html"){
                                $is_html = true;
                            }else{
                                // convert body to html, so we can do wrap.
                                $body = nl2br($body);
                                $is_html = true;
                            }
                            // find the alt body.
                            $altbody = '';
                            if(isset($results['Alternative']) && is_array($results['Alternative'])){
                                foreach($results['Alternative'] as $alt_id => $alt){
                                    if($alt['Type']=="text"){
                                        $altbody = $alt['Data'];
                                        break;
                                    }
                                }
                            }

                            if(!$altbody){
                                // should really never happen, but who knows.
                                $altbody = $body; // todo: strip any html.
                            }

                            

                            // pass the body and altbody through a hook so we can modify it if needed.
                            // eg: for envato tickets we strip the header/footer out and check the link to see if the buyer really bought anything.
                            // run_hook(...

                            //echo "<hr>$body<hr>$altbody<hr><br><br><br>";
                            // save the message!
                            $ticket_message_id = wpetss_update_insert('ticket_message_id','new','wpetss_ticket_message',array(
                                                                 'ticket_id' => $ticket_id,
                                                                  'message_id' => $message_id,
                                                                 'content' => $altbody,
                                                                 // save html content later on.
                                                                 'htmlcontent' => $body,
                                                                 'message_time' => strtotime($overview->date),
                                                                 'message_type_id' => 1, // from a support user.
                                                                 'from_user_id' => $from_user_id,
                                                                 'to_user_id' => $to_user_id,
                                                                  'cache' => serialize($cache),
                            ));

                            if(isset($results['Related'])){
                                foreach($results['Related'] as $related){
                                    if(isset($related['FileName']) && $related['FileName']){
                                        // save as attachment against this email.
                                        $attachment_id = wpetss_update_insert('ticket_message_attachment_id','new','wpetss_ticket_message_attachment',array(
                                                                                                         'ticket_id' => $ticket_id,
                                                                                                         'ticket_message_id' => $ticket_message_id,
                                                                                                         'file_name' => $related['FileName'],
                                                                                                         'content_type' => $related['Type'].'/'.$related['SubType'],
                                                                                                                                        ));
                                        file_put_contents(_TMP_DIR.'attach-'.$ticket_id.'-'.$attachment_id.'',$related['Data']);
                                    }
                                }
                            }
                            if(isset($results['Attachments'])){
                                foreach($results['Attachments'] as $related){
                                    if(isset($related['FileName']) && $related['FileName']){
                                        // save as attachment against this email.
                                        $attachment_id = wpetss_update_insert('ticket_message_attachment_id','new','wpetss_ticket_message_attachment',array(
                                                                                                         'ticket_id' => $ticket_id,
                                                                                                         'ticket_message_id' => $ticket_message_id,
                                                                                                         'file_name' => $related['FileName'],
                                                                                                         'content_type' => $related['Type'].'/'.$related['SubType'],
                                                                                                                                        ));
                                        file_put_contents(_TMP_DIR.'attach-'.$ticket_id.'-'.$attachment_id.'',$related['Data']);
                                    }
                                }
                            }

                            if($new_message && !preg_match('#failure notice#i',$this_subject)){
                                module_ticket::send_autoreply($ticket_id);
                            }

                            $parse_success = true;

                        }
                    }
                }
            }

            if($parse_success && $account['delete']){
                // remove email from inbox if needed.
                imap_delete($mbox, $overview->msgno);
            }
            
            unlink($tmp_file);
        }
        imap_expunge($mbox);
        imap_close($mbox);

    imap_errors();
    }


    imap_errors();
