<?php



class module_ticket{

    public static $ticket_statuses = array();
    public static $default_autoresponder = 'Hello,

Thank you for your ticket. We will reply shortly.

';
    public static $default_reply_above = '----- (Please reply above this line) -----';
    public static $default_template = '<span style="font-size:10px; color:#999999;">{REPLY_LINE}</span>
<span style="font-size:10px; color:#999999;">Your ticket has been updated, please see the message below:</span>


{MESSAGE}


<span style="font-size:10px; color:#999999;">Ticket Number: <strong>{TICKET_NUMBER}</strong></span>
<span style="font-size:10px; color:#999999;">Ticket Status: <strong>{TICKET_STATUS}</strong></span>
<span style="font-size:10px; color:#999999;">Your position in the support queue: <strong>{POSITION_CURRENT} out of {POSITION_ALL}</strong>.</span>
<span style="font-size:10px; color:#999999;">Estimated time for a reply: <strong>within {DAYS} days</strong></span>
<span style="font-size:10px; color:#999999;">You can view the status of your support query at any time by following this link:</span>
<span style="font-size:10px; color:#999999;"><a href="{URL}" style="color:#999999;">View Ticket {TICKET_NUMBER} Online</a></span>

';
    public static $default_admin_alert = 'Hello, a new ticket has been created.
Ticket Number: {TICKET_NUMBER}
Ticket Subject: {SUBJECT}
Please click here to view/action the ticket:
{URL_ADMIN}';
    public static $default_admin_alert_subject = 'New Ticket Alert';

    public static function init(){
        self::$ticket_statuses = array(
            //1 => __('Unassigned', 'wpetss', 'wpetss'),
            2 => __('New', 'wpetss', 'wpetss'),
            3 => __('Replied', 'wpetss', 'wpetss'),
            5 => __('In Progress', 'wpetss', 'wpetss'),
            6 => __('Resolved', 'wpetss'),
            7 => __('Canceled', 'wpetss'),
        );
	}


    public static function ticket_number($id){
        $id=(int)$id;
        if(!$id)return __('New', 'wpetss');
        return str_pad($id,6,'0',STR_PAD_LEFT);
    }


    public static function ticket_count($type,$time = false){
        global $wpdb;
        $table_name = $wpdb->prefix . "wpetss_ticket";
        $sql = "SELECT COUNT(ticket_id) AS c FROM `".$table_name."` t WHERE t.status_id < 6";
        if($time){
            $sql .= " AND t.last_message_timestamp <= ".(int)$time."";
        }
        $res = $wpdb->get_row($sql);
        return $res->c;
    }




    public static function get_tickets($search){
        global $wpdb;
        $table_name = $wpdb->prefix . "wpetss_ticket";

        $sql = "SELECT t.*, COUNT(tm.ticket_message_id) AS message_count ";
        $sql .= ", tu.name AS user_name, tu.email AS user_email, tu.wp_user_id ";
        $from = " FROM `".$wpdb->prefix."wpetss_ticket` t ";
        $from .= " LEFT JOIN `".$wpdb->prefix."wpetss_ticket_message` tm ON t.ticket_id = tm.ticket_id ";
        $from .= " LEFT JOIN `".$wpdb->prefix."wpetss_ticket_user` tu ON t.user_id = tu.user_id ";
        $where = " WHERE 1 ";
        if(isset($search['generic']) && $search['generic']){
            $str = $wpdb->escape($search['generic']);
            $where .= " AND ( ";
            $where .= " t.subject LIKE '%$str%' ";
            $where .= ' ) ';
        }
        if(isset($search['ticket_id'])){
            $search['ticket_id'] = trim(ltrim($search['ticket_id'],'0'));
        }
        if(isset($search['status_id']) && strpos($search['status_id'],',') !== false){
            $where .= ' AND ( ';
            foreach(explode(',',$search['status_id']) as $s){
                $s = (int)trim($s);
                if(!$s)continue;
                $where .= ' t.`status_id` = '.$s.' OR ';
            }
            $where = rtrim($where,' OR ');
            $where .= ' ) ';
            unset($search['status_id']);
        }
        if(isset($search['status_id']) && !$search['status_id']){
            unset($search['status_id']);//hack
        }
        foreach(array('user_id','assigned_user_id','customer_id','website_id','ticket_id','status_id','unread','type') as $key){
            if(isset($search[$key]) && $search[$key] !== ''&& $search[$key] !== false){
                $str = $wpdb->escape($search[$key]);
                $where .= " AND t.`$key` = '$str'";
            }
        }
        $group_order = ' GROUP BY t.ticket_id ORDER BY t.unread DESC, t.last_message_timestamp ASC';
        $sql = $sql . $from . $where . $group_order;
        $alltickets = $wpdb->get_results($sql,ARRAY_A);
        return $alltickets;
    }

    public static function get_ticket_message_attachments($ticket_message_id){
        global $wpdb;

        $table_name_attach = $wpdb->prefix . "wpetss_ticket_message_attachment";

        return  $wpdb->get_results("SELECT * FROM $table_name_attach WHERE ticket_message_id = '$ticket_message_id'",ARRAY_A);

    }

    public static function get_ticket_messages($ticket_id){
        global $wpdb;

        $table_name_attach = $wpdb->prefix . "wpetss_ticket_message";
        $table_name_user = $wpdb->prefix . "wpetss_ticket_user";

        return  $wpdb->get_results("SELECT m.*, fu.name AS from_name, fu.email AS from_email, fu.wp_user_id AS from_wp_user_id, tu.name AS to_name, tu.email AS to_email, tu.wp_user_id AS to_wp_user_id FROM $table_name_attach m LEFT JOIN $table_name_user fu ON m.from_user_id = fu.user_id LEFT JOIN $table_name_user tu ON m.to_user_id = tu.user_id WHERE m.ticket_id = '$ticket_id' ORDER BY ticket_message_id",ARRAY_A);

    }

    public static function get_ticket_accounts(){
        global $wpdb;

        $table_name = $wpdb->prefix . "wpetss_ticket_account";

        return  $wpdb->get_results("SELECT * FROM $table_name",ARRAY_A);

    }

    public static function get_ticket_account($ticket_account_id){
        global $wpdb;

        $table_name = $wpdb->prefix . "wpetss_ticket_account";

        return  $wpdb->get_row("SELECT * FROM $table_name WHERE ticket_account_id = '$ticket_account_id'",ARRAY_A);

    }
    public static function get_user($user_id){
        global $wpdb;

        $table_name = $wpdb->prefix . "wpetss_ticket_user";

        return  $wpdb->get_row("SELECT * FROM $table_name WHERE user_id = '$user_id'",ARRAY_A);

    }
    public static function user_from_email($email,$name=''){
        global $wpdb;
        $table_name_user = $wpdb->prefix . "wpetss_ticket_user";
        $email = strtolower(trim($email));
        if(!$email)return false;



        // todo: better email verification
        $email = $wpdb->escape($email);
        $ticket_user = $wpdb->get_row("SELECT * FROM $table_name_user WHERE email = '$email'",ARRAY_A);

        if($ticket_user && count($ticket_user) && $ticket_user['email'] == $email){
            // found a user!
            // use this one.
            $creator_user_id = $ticket_user['user_id'];
        }else{
            // search for this user in the WP database.
            $wp_user = get_user_by_email($email);
            if($wp_user){
                $wp_user_id = $wp_user->ID;
                $wp_user = get_userdata($wp_user_id);
                if(!trim($name)){
                    $name = $wp_user->display_name;
                }
            }else{
                $wp_user_id = 0;
            }
            // create an entry in the db ticket user table for this new user.
            $sql = "INSERT INTO $table_name_user SET ";
            $sql .= " `email` = '".$wpdb->escape($email)."', ";
            $sql .= " `name` = '".$wpdb->escape($name)."', ";
            $sql .= " `wp_user_id` = '".$wpdb->escape($wp_user_id)."' ";
            $wpdb->query($sql);
            $creator_user_id = $wpdb->insert_id;
        }
        return $creator_user_id;

    }

    public static function user_from_wp_id($wp_user_id){

        $wp_user = get_userdata($wp_user_id);
        return self::user_from_email($wp_user->user_email,$wp_user->display_name);

    }

	public static function get_ticket($ticket_id){


        $ticket_id = (int)$ticket_id;
        $ticket = false;
        if($ticket_id>0){
            $ticket = array_shift(self::get_tickets(array('ticket_id'=>$ticket_id)));
        }
        if(!$ticket){
            $ticket = array(
                'ticket_id' => 'new',
                'subject' => '',
                'date_completed' => '',
                'status_id'  => 2, // new
                'user_id'  => 0,
                'assigned_user_id'  => 0,
                'last_message_timestamp'  => 0,
                'position'  => self::ticket_count('pending') + 1,
                'type'  => get_option('ticket_default_type','General Support'),
                'total_pending' => self::ticket_count('pending') + 1,
            );

        }else{
            // find the position of this ticket
            // the position is determined by the number of pending tickets
            // that have a last_message_timestamp earlier than this ticket.
            $ticket['position'] = self::ticket_count('pending',$ticket['last_message_timestamp']);
            $ticket['total_pending'] = self::ticket_count('pending');
        }
		return $ticket;
	}

    public static function mark_as_read($ticket_id){
        $ticket_id=(int)$ticket_id;
        if($ticket_id>0){
            wpetss_update_insert("ticket_id",$ticket_id,"wpetss_ticket",array('unread'=>0));
        }
    }
    public static function mark_as_unread($ticket_id){
        $ticket_id=(int)$ticket_id;
        if($ticket_id>0){
            wpetss_update_insert("ticket_id",$ticket_id,"wpetss_ticket",array('unread'=>1));
        }
    }

	public static function save_ticket($ticket_id,$data){

        $ticket_id = (int)$ticket_id;

        global $wpdb;
        $table_name = $wpdb->prefix . "wpetss_ticket";
        $table_name_user = $wpdb->prefix . "wpetss_ticket_user";
        $creator_user_id = 0;
        if(is_user_logged_in()){
            // we're posting from a wp user account.
            $wp_user_id = get_current_user_id();
            // see if this user exists in the ticket user table.
            $ticket_user = $wpdb->get_row("SELECT * FROM $table_name_user WHERE wp_user_id = '$wp_user_id'",ARRAY_A);
            if(count($ticket_user) && $ticket_user['wp_user_id'] == $wp_user_id){
                // found a user id!
                $creator_user_id = $ticket_user['user_id'];
            }else{
                // no entry yet.
                $wp_user = get_userdata($wp_user_id);
                $sql = "INSERT INTO $table_name_user SET ";
                $sql .= " `email` = '".$wpdb->escape($wp_user->user_email)."', ";
                $sql .= " `name` = '".$wpdb->escape($wp_user->display_name)."', ";
                $sql .= " `wp_user_id` = '".$wpdb->escape($wp_user_id)."' ";
                $wpdb->query($sql);
                $creator_user_id = $wpdb->insert_id;
            }
        }else if(isset($_REQUEST['creator_id']) && isset($_REQUEST['creator_hash'])){
            $real_hash = self::creator_hash($_REQUEST['creator_id']);
            if($real_hash == $_REQUEST['creator_hash']){
                $creator_user_id = $_REQUEST['creator_id'];
            }
        }else{
            // we're posting from a public account.
            // check required fields.
            if(!trim($data['subject'])){
                return false;
            }
            if(!trim($data['new_ticket_message'])){
                return false;
            }
            // check this user has a valid email address, find/create a user in the ticket user table.
            // see if this email address exists in the wp user table, and link that user there.
            $email = trim(strtolower($data['email']));
            if(strpos($email,'@')){

                $creator_user_id = self::user_from_email($email,$data['name']);
            }
            if(!$creator_user_id){
                // sorry - no user created.
                return false;
            }
        }

        // todo
        if(!self::can_edit_tickets()){
            // remove certain fields from the $data
            // array so people cant change them...
            
        }

        // now save the ticket details.
        if(!$ticket_id){
            $available_assign = self::get_assignable_users_rel();

            // todo - make this secure so the user cant asisgn their own accounts on public post..
            if(isset($_REQUEST['tac']) && $_REQUEST['tac']){
                $ticket_account_id = (int)$_REQUEST['tac'];
            }else{
                // pick the first available / default ticket account.
                $ticket_account_id = get_option('ticket_default_account',1);
            }

            $ticket_account = array();
            if((int)$ticket_account_id > 0){
                $ticket_account = self::get_ticket_account($ticket_account_id);
                if(!$ticket_account){
                    $ticket_account_id = 0;
                }
            }
            if((!isset($data['ticket_account_id']) || !$data['ticket_account_id']) && $ticket_account_id){
                $data['ticket_account_id'] = $ticket_account_id;
            }
            if(isset($ticket_account) && isset($ticket_account['default_user_id'])){
                $data['assigned_user_id'] = $ticket_account['default_user_id'];
            }
            $data['user_id'] = $creator_user_id;
            $data['unread'] = 1;
            $data['status_id'] = 2;
        }
        $ticket_id = wpetss_update_insert('ticket_id',$ticket_id,'wpetss_ticket',$data);

        if($ticket_id){


            if($creator_user_id && isset($data['new_ticket_message']) && strlen($data['new_ticket_message']) > 1){
                // post a new reply to this message.
                // who are we replying to?
                // it's either a reply from the admin, or from the user via the web interface.
                $ticket_data = self::get_ticket($ticket_id);
                //print_r($ticket_data);echo $creator_user_id;exit;
                $ticket_creator = $ticket_data['user_id'];


                if($ticket_data['status_id']==6 || $ticket_data['status_id'] == 7){
                    $data['change_status_id'] = 5;
                }

                if(isset($data['change_status_id']) && $data['change_status_id']){
                    //$data['status_id']=$data['change_status_id'];
                    wpetss_update_insert("ticket_id",$ticket_id,"wpetss_ticket",array('status_id'=>$data['change_status_id']));
                }
                $ticket_message_id = false;
                if($ticket_creator == $creator_user_id){
                    // the currently logged in user is the person who started this ticket.
                    // this message has to go to the administrator.
                    self::mark_as_unread($ticket_id);
                    $wp_admin_user_id = 1;
                    // find user id 1 in the db:
                    $ticket_user = $wpdb->get_row("SELECT * FROM $table_name_user WHERE wp_user_id = 1",ARRAY_A);
                    if(count($ticket_user) && $ticket_user['wp_user_id'] == 1){
                        // found a user id!
                        $wp_admin_user_id = $ticket_user['user_id'];
                    }
                    $to_user_id = $ticket_data['assigned_user_id'] ? $ticket_data['assigned_user_id'] : $wp_admin_user_id;
                    $ticket_message_id = self::send_reply($ticket_id,$data['new_ticket_message'], $creator_user_id, $to_user_id, 'end_user');
                }else{
                    // we are sending a reply back to the ticket user.
                    $from_user_id = $ticket_data['assigned_user_id'] ? $ticket_data['assigned_user_id'] : $creator_user_id;
                    $ticket_message_id = self::send_reply($ticket_id,$data['new_ticket_message'], $from_user_id, $ticket_creator);
                }



            }

        }
		return $ticket_id;
	}

	public static function delete_ticket($ticket_id){
        global $wpdb;
		$ticket_id=(int)$ticket_id;
		$sql = "DELETE FROM ".$wpdb->prefix."wpetss_ticket WHERE ticket_id = '".$ticket_id."' LIMIT 1";
		$res = wpetss_query($sql);
		$sql = "DELETE FROM ".$wpdb->prefix."wpetss_ticket_message WHERE ticket_id = '".$ticket_id."'";
		$res = wpetss_query($sql);
		$sql = "DELETE FROM ".$wpdb->prefix."wpetss_ticket_message_attachment WHERE ticket_id = '".$ticket_id."'";
		$res = wpetss_query($sql);

	}


    public static function get_statuses(){
        return self::$ticket_statuses;
    }

    public static function get_types(){
        global $wpdb;
        $sql = "SELECT `type` FROM `".$wpdb->prefix."wpetss_ticket` GROUP BY `type` ORDER BY `type`";
        $statuses = array();
        foreach($wpdb->get_results($sql) as $r){
            $r=(array)$r;
            $statuses[$r['type']] = $r['type'];
        }
        // find any defaults.
        $defaults = get_option('ticket_default_types','Website Problem,Billing Enquiry,Sales,General Support,Other');
        foreach(explode(',',$defaults) as $default){
            $default = trim($default);
            if(!$default)continue;
            if(!isset($statuses[$default])){
                $statuses[$default] = $default;
            }
        }
        ksort($statuses);
        return $statuses;
    }

    public static function send_autoreply($ticket_id){
        $ticket_data = self::get_ticket($ticket_id);
        $auto_responder = get_option('ticket_auto_responder',self::$default_autoresponder);
        $wp_admin_user_id = 1;
        global $wpdb;
        // find user id 1 in the db:
        $table_name_user = $wpdb->prefix . "wpetss_ticket_user";
        $ticket_user = $wpdb->get_row("SELECT * FROM $table_name_user WHERE wp_user_id = 1",ARRAY_A);
        if(count($ticket_user) && $ticket_user['wp_user_id'] == 1){
            // found a user id!
            $wp_admin_user_id = $ticket_user['user_id'];
        }
        $from_user_id = $ticket_data['assigned_user_id'] ? $ticket_data['assigned_user_id'] : $wp_admin_user_id;
        //if($ticket_data['user_id'] != $from_user_id){
            return self::send_reply($ticket_id,$auto_responder, $from_user_id, $ticket_data['user_id'], 'admin');
       // }
    }

    public static function send_reply($ticket_id,$message,$from_user_id,$to_user_id, $reply_type = 'admin'){

        $ticket_number = self::ticket_number($ticket_id);
        $ticket_details = self::get_ticket($ticket_id);


        $to_user_a = self::get_user($to_user_id);
        $from_user_a = self::get_user($from_user_id);

        // the from details need to match the ticket account details.
        if($ticket_details['ticket_account_id']){
            $ticket_account = self::get_ticket_account($ticket_details['ticket_account_id']);
        }else{
            $ticket_account = false;
        }
        if($ticket_account && $ticket_account['email']){
            $reply_to_address = $ticket_account['email'];
            $reply_to_name = $ticket_account['name'];
        }else{
            // reply to creator.
            $reply_to_address = $from_user_a['email'];
            $reply_to_name = $from_user_a['name'];
        }


        $ticket_message_id = wpetss_update_insert('ticket_message_id','new','wpetss_ticket_message',array(
                                             'ticket_id' => $ticket_id,
                                             'content' => $message,
                                             'message_time' => time(),
                                             'from_user_id' => $from_user_id,
                                             'to_user_id' => $to_user_id,
                                     ));

        if(!$ticket_message_id)return false;



        // are there any attachments?
        if($ticket_message_id && isset($_FILES['attachment']) && isset($_FILES['attachment']['tmp_name']) && is_array($_FILES['attachment']['tmp_name'])){
            foreach($_FILES['attachment']['tmp_name'] as $key => $val){
                if(is_uploaded_file($val)){
                    // save attachments against ticket!

                    $finfo = finfo_open(FILEINFO_MIME_TYPE);
                    $mime = finfo_file($finfo, $val);

                    $attachment_id = wpetss_update_insert('ticket_message_attachment_id','new','wpetss_ticket_message_attachment',array(
                                             'ticket_id' => $ticket_id,
                                             'ticket_message_id' => $ticket_message_id,
                                             'file_name' => $_FILES['attachment']['name'][$key],
                                             'content_type' => $mime,
                                    ));
                    move_uploaded_file($val, _TMP_DIR.'attach-'.$ticket_id.'-'.$attachment_id.'');
                }
            }
        }

        //echo "Sending reply: $ticket_message_id ";exit;

        wpetss_update_insert('ticket_id',$ticket_id,'wpetss_ticket',array(
                                     'last_message_timestamp' => time(),
                              ));
       

        $reply_line = get_option('ticket_reply_line',self::$default_reply_above);
        $content = get_option('ticket_template',self::$default_template);
        $content = nl2br($content);
        $message = nl2br($message);
        //

        $s = self::get_statuses();

        $replace = array(
             'ticket_number' => self::ticket_number($ticket_id),
             'ticket_status' => $s[$ticket_details['status_id']],
             'message' => $message,
             'subject' => $ticket_details['subject'],
             'position_current' => $ticket_details['position'],
             'position_all' => self::ticket_count('pending'), // all tickets that are less than status 6 (resolved)
             'reply_line' => $reply_line,
             'days' => get_option('ticket_turn_around_days',5),
             'units' => get_option('ticket_turn_around_units','days'),
             'url' => self::link_public($ticket_id),
         );

        foreach($replace as $key=>$val){
			$val = str_replace(array('\\', '$'), array('\\\\', '\$'), $val);
			$content = preg_replace('/\{'.strtoupper(preg_quote($key,'/')).'\}/',$val,$content);
        }

        /**
         * We want to email the CUSTOMER an email with an update on their ticket when:
         *  - the user submits a ticket via our website (new ticket)
         *  - the users email is received via POP3 (ie: sending an auto responder)
         *  - teh admin writes an update to the users ticket via web interface.
         */

        //echo "FROM $from_user_id TO $to_user_id"; print_r($ticket_details); print_r($to_user_a); print_r($from_user_a); exit;
        $to = get_option('ticket_email_alert',get_option('admin_email'));
        if($reply_type == 'end_user' && !$ticket_details['message_count']){
            // this is the first message!
            // send an email back to the user confirming this submissions via the web interface.
            self::send_autoreply($ticket_id);
        }
        if($to_user_id == $ticket_details['user_id']) {
            // onyl send email if we're emailing the user from the UI
            // if no to user, work out email based on first 'from' address.

            // send email to admin about new ticket.
            require_once('dtbakerphpmailer/class.phpmailer.php');
            $mail = new wpetss_PHPMailer(true);
            try {
                if(_MAIL_USE_SMTP){
                    $mail->IsSMTP(); // telling the class to use SMTP
                    $mail->Host       = _MAIL_SMTP_HOST; // SMTP server
                    if(_MAIL_USERNAME&&_MAIL_PASSWORD){
                        $mail->SMTPAuth   = true;                  // enable SMTP authentication
                        $mail->Username   = _MAIL_USERNAME; // SMTP account username
                        $mail->Password   = _MAIL_PASSWORD;        // SMTP account password
                    }
                }
                $mail->Sender = $reply_to_address;
                $mail->AddReplyTo($reply_to_address,$reply_to_name);
                $mail->SetFrom($from_user_a['email'],$from_user_a['name']);
                $mail->AddAddress($to_user_a['email'],$to_user_a['name']);
                $mail->Subject = '[TICKET:'.$ticket_number.'] Re: '.$ticket_details['subject'];

                // check attachments:
                $attachments = self::get_ticket_message_attachments($ticket_message_id);
                foreach($attachments as $attachment){
                    $file_path = _TMP_DIR.'attach-'.$ticket_id.'-'.$attachment['ticket_message_attachment_id'];
                    $file_name = $attachment['file_name'];
                    $mail->AddAttachment($file_path,$file_name);
                }

                $mail->MsgHTML($content); // . var_export($from_user_a,true).var_export($to_user_a,true));
                if(!$mail->Send()){
                    echo 'Error sending.' . $mail->ErrorInfo;
                }else{
                    // success.
                }
            } catch (Exception $e) {
                echo $e->getMessage();
            }

        }else if (strlen($to)>4){

            // do we only send this on first emails or not ?
            $first_only = get_option('ticket_admin_alert_first_only',1);
            if($first_only && $ticket_details['message_count'] > 0)return;

            // send an alert to the admin letting them know there's a new ticket.
            require_once('dtbakerphpmailer/class.phpmailer.php');
            $mail = new wpetss_PHPMailer(true);
            try {
                if(_MAIL_USE_SMTP){
                    $mail->IsSMTP(); // telling the class to use SMTP
                    $mail->Host       = _MAIL_SMTP_HOST; // SMTP server
                    if(_MAIL_USERNAME&&_MAIL_PASSWORD){
                        $mail->SMTPAuth   = true;                  // enable SMTP authentication
                        $mail->Username   = _MAIL_USERNAME; // SMTP account username
                        $mail->Password   = _MAIL_PASSWORD;        // SMTP account password
                    }
                }
                $mail->Sender = $to;
                $mail->AddReplyTo($to);
                //$mail->SetFrom($from_user_a['email'],$from_user_a['name']);
                $mail->SetFrom($to);
                $mail->AddAddress($to);
                $mail->Subject = get_option('ticket_admin_alert_subject',self::$default_admin_alert_subject);

                $admin_content = get_option('ticket_admin_alert',self::$default_admin_alert);
                $admin_content = nl2br($admin_content);
                $replace = array(
                     'ticket_number' => self::ticket_number($ticket_id),
                     'ticket_status' => $s[$ticket_details['status_id']],
                     'subject' => $ticket_details['subject'],
                     'message' => $message,
                     'position_current' => $ticket_details['position'],
                     'position_all' => self::ticket_count('pending'), // all tickets that are less than status 6 (resolved)
                     'reply_line' => $reply_line,
                     'days' => get_option('ticket_turn_around_days',5),
                     'units' => get_option('ticket_turn_around_units','days'),
                     'url' => self::link_public($ticket_id),
                     'url_admin' => get_admin_url().'admin.php?page=wpetss-edit-ticket&ticket_id='.$ticket_id.'&view=foo',
                 );

                foreach($replace as $key=>$val){
                    $val = str_replace(array('\\', '$'), array('\\\\', '\$'), $val);
                    $admin_content = preg_replace('/\{'.strtoupper(preg_quote($key,'/')).'\}/',$val,$admin_content);
                }

                $mail->MsgHTML($admin_content);
                if(!$mail->Send()){
                    echo 'Error sending.' . $mail->ErrorInfo;
                }else{
                    // success.
                }
            } catch (Exception $e) {
                echo $e->getMessage();
            }

        }

        return $ticket_message_id;

    }

    public static function link_public($ticket_id,$h=false){
        if($h){
            return md5('s3cret7hash for tickets '.$ticket_id.SECURE_AUTH_KEY);
        }
        return get_home_url().'?wpetss=public&i='.$ticket_id.'&hash='.self::link_public($ticket_id,true);
    }

    public static function get_assignable_users_rel(){
        $c = array();
        $res = module_ticket::get_assignable_users();
        foreach($res as $row){
            $c[$row['user_id']] = $row['name'];
        }
        return $c;
    }

    public static function get_assignable_users(){
        $valid_users = array();
        $szSort = "user_nicename";
        global $wpdb;
        $table_name_user = $wpdb->prefix . "wpetss_ticket_user";
        $aUsersID = $wpdb->get_col( $wpdb->prepare(
            "SELECT $wpdb->users.ID FROM $wpdb->users ORDER BY %s ASC"
            , $szSort ));
        foreach ( $aUsersID as $iUserID ){
            $user = get_userdata( $iUserID );
            if($user->{$wpdb->prefix.'capabilities'}){
                if(
                    $user->{$wpdb->prefix.'capabilities'}['administrator'] ||
                    $user->{$wpdb->prefix.'capabilities'}['editor'] ||
                    $user->{$wpdb->prefix.'capabilities'}['contributor']

                ){
                    $our_user_id = 0;
                    $ticket_user = $wpdb->get_row("SELECT * FROM $table_name_user WHERE wp_user_id = '$iUserID'",ARRAY_A);
                    if(count($ticket_user) && $ticket_user['wp_user_id'] == $iUserID){
                        // found a user id!
                        $our_user_id = $ticket_user['user_id'];
                    }else{
                        // no entry yet, make one in our table..
                        $wp_user = get_userdata($iUserID);
                        $sql = "INSERT INTO $table_name_user SET ";
                        $sql .= " `email` = '".$wpdb->escape($wp_user->user_email)."', ";
                        $sql .= " `name` = '".$wpdb->escape($wp_user->display_name)."', ";
                        $sql .= " `wp_user_id` = '".$wpdb->escape($iUserID)."' ";
                        $wpdb->query($sql);
                        $our_user_id = $wpdb->insert_id;
                    }
                    if($our_user_id){
                        $valid_users[] = array( 'user_id'=>$our_user_id, 'name' => $user->display_name);
                    }
                }
            }
        }
        return $valid_users;
    }
    public static function can_edit_tickets(){
        return current_user_can('manage_options');
    }

    public static function creator_hash($creator_id){
        return md5($creator_id.'secret key! '.SECURE_AUTH_KEY);
    }

    public static function check_all_accounts(){
        $accounts = self::get_ticket_accounts();
        foreach($accounts as $account){
            self::check_ticket_account($account['ticket_account_id']);
        }
    }
    public static function check_ticket_account($ticket_account_id){
        $ticket_account_id = (int)$ticket_account_id;
        if($ticket_account_id <= 0)return false;

        $account = self::get_ticket_account($ticket_account_id);
        if(!$account)return false;

        global $wpdb;
        $status = true;
        include('read_emails.php');
        return $status;

    }


}