<?php


$logged_in_user = 0;
if(is_user_logged_in()){
    $wp_user_id = get_current_user_id();
    // find their user id in the wp table.
    global $wpdb;
    $table_name_user = $wpdb->prefix . "wpetss_ticket_user";
    $ticket_user = $wpdb->get_row("SELECT * FROM $table_name_user WHERE wp_user_id = '$wp_user_id'",ARRAY_A);
    if(count($ticket_user) && $ticket_user['wp_user_id'] == $wp_user_id){
        // found a user id!
        $logged_in_user = $ticket_user['user_id'];
    }
}
if(!$logged_in_user){
    // we assume the user is on the public side.
    // use the creator id as the logged in id.
    $logged_in_user = $ticket['user_id'];
}
$ticket_creator = $ticket['user_id'];
if($ticket_creator == $logged_in_user){
    // we are sending a reply back to the admin, from the end user.
    $to_user_id = $ticket['assigned_user_id'] ? $ticket['assigned_user_id'] : 1;
    $from_user_id = $logged_in_user;
}else{
    // we are sending a reply back to the ticket user.
    $to_user_id = $ticket['user_id'];
    $from_user_id = $logged_in_user;
}
$to_user_a = module_ticket::get_user($to_user_id);
$from_user_a = module_ticket::get_user($from_user_id);

if($ticket['ticket_account_id']){
    $ticket_account = module_ticket::get_ticket_account($ticket['ticket_account_id']);
}else{
    $ticket_account = false;
}

if($ticket_account && $ticket_account['email']){
    $reply_to_address = $ticket_account['email'];
    $reply_to_name = $ticket_account['name'];
}else{
    // reply to creator.
    $reply_to_address = $from_user_a['email'];
    $reply_to_name = $from_user_a['name'];
}


if($ticket_creator == $logged_in_user){
    $send_as_name = $from_user_a['name'];
    $send_as_address = $from_user_a['email'];
}else{
    $send_as_address = $reply_to_address;
    $send_as_name = $reply_to_name;
}

?>

<div id="wpetss_holder" class="wrap">

<form action="" method="post" id="ticket_form" enctype="multipart/form-data">

<?php
    module_form::set_required(array(
                                  'fields' => array(
                                      'type' => __('Department', 'wpetss'),
                                      'subject' => __('Subject', 'wpetss'),
                                  ),
                              ));
    ?>

	<input type="hidden" name="_wpetss_process" value="save_ticket" />
    <input type="hidden" name="ticket_id" value="<?php echo $ticket_id; ?>" />

	<table cellpadding="10" width="100%" class="wpetss">
		<tbody>
			<tr>
				<td valign="top" width="35%" style="padding:10px;">

                   
					<h3><?php echo __('Ticket Details', 'wpetss'); ?></h3>

					<table border="0" cellspacing="0" cellpadding="2" class="tableclass tableclass_form tableclass_full">
						<tbody>
							<tr>
								<th class="width1">
									<?php echo __('Ticket Number', 'wpetss'); ?>
								</th>
								<td>
									<?php echo module_ticket::ticket_number($ticket['ticket_id']);?>
								</td>
							</tr>
                            <?php if ($ticket['status_id'] == 2 || $ticket['status_id'] == 3 || $ticket['status_id'] == 5){ ?>
                            <tr>
								<th class="width1">
									<?php echo __('Position', 'wpetss'); ?>
								</th>
								<td>
									<?php echo sprintf(__('%s out of %s tickets', 'wpetss'),wpetss_ordinal($ticket['position']),$ticket['total_pending']); ?>
                                </td>
                            </tr>
                            <tr>
								<th class="width1">
									<?php echo __('Reply', 'wpetss'); ?>
								</th>
								<td>
									<?php echo sprintf(__('We will reply within %s %s of your last message', 'wpetss'),get_option('ticket_turn_around_days',5),get_option('ticket_turn_around_units','days')); ?>
                                </td>
                            </tr>
                            <?php } ?>
                            <tr>
                                <th>
                                    <?php _e('Subject', 'wpetss');?>
                                </th>
                                <td>
                                    <?php if($ticket['subject']){
                                    echo htmlspecialchars($ticket['subject']);
                                }else{ ?>
                                    <input type="text" name="subject" id="subject" value="<?php echo htmlspecialchars($ticket['subject']); ?>" />
    <?php } ?>
                                </td>
                            </tr>
                            <?php if(module_ticket::can_edit_tickets()){ ?>
							<tr>
								<th>
									<?php echo __('Assigned User', 'wpetss'); ?>
								</th>
								<td>
									<?php
                                    // if we are a wordpress user we can assign this to a different admin.
                                    $admins_rel = module_ticket::get_assignable_users_rel();
                                    if(module_ticket::can_edit_tickets()){
                                        echo wpetss_print_select_box($admins_rel,'assigned_user_id',$ticket['assigned_user_id']);
                                    }else if($ticket['assigned_user_id']){
                                        echo $admins_rel[$ticket['assigned_user_id']];
                                    }else{
                                        echo __('N/A', 'wpetss');
                                    }
                                    ?>
								</td>
							</tr>
                            <?php } ?>
							<tr>
								<th>
									<?php echo __('Department', 'wpetss'); ?>
								</th>
								<td>
									<?php
                                    $types = module_ticket::get_types();
                                    if(module_ticket::can_edit_tickets()){
                                        echo wpetss_print_select_box($types,'type',$ticket['type'],'',true,false,true);
                                    }else{
                                        echo $types[$ticket['type']];
                                    }
                                    ?>
								</td>
							</tr>
							<tr>
								<th>
									<?php echo __('Status', 'wpetss'); ?>
								</th>
								<td>
									<?php
                                    //echo wpetss_print_select_box(module_ticket::get_statuses(),'status_id',$ticket['status_id'],'',true,false,true);
                                    $s = module_ticket::get_statuses();
                                    echo $s[$ticket['status_id']]; ?>
								</td>
							</tr>
                            <?php if(module_ticket::can_edit_tickets()){ ?>
							<tr>
								<th>
									<?php echo __('Account', 'wpetss'); ?>
								</th>
								<td>
									<?php
                                    echo isset($ticket_account['name']) ? htmlspecialchars($ticket_account['name']) : 'None?';
                                    ?>
								</td>
							</tr>
                            <?php } ?>
                            <?php
                            if($ticket['user_id']){
                                $other_tickets = module_ticket::get_tickets(array('user_id'=>$ticket['user_id']));

                                ?>
                                    <tr>
                                        <th>
                                            <?php echo __('Ticket Creator', 'wpetss'); ?>
                                        </th>
                                        <td>
                                            <?php echo htmlspecialchars($ticket['user_name']); ?>
                                           <?php if($ticket['wp_user_id']){
                                            echo '<a href="profile.php?user_id='.$ticket['wp_user_id'].'">';
                                            echo '(WP:';
                                            $user = get_userdata($ticket['wp_user_id']);
                                            echo $user->display_name;
                                           echo ')</a>'; } ?><br/>
                                            <?php echo htmlspecialchars($ticket['user_email']); ?>
                                            <?php if (count($other_tickets) > 1 && module_ticket::can_edit_tickets()){ ?>
                                        <br/>
                                            <a href="<?php echo get_admin_url();?>admin.php?page=wpetss-dashboard&wpetss_search[status_id]=0&wpetss_search[user_id]=<?php echo $ticket['user_id'];?>"><?php echo sprintf(__('View users other <strong>%s</strong> support emails.', 'wpetss'),count($other_tickets));?></a>
                                        <?php } ?>
                                        </td>
                                    </tr>
                            <?php }
                            if((int)$ticket_id>0  && module_ticket::can_edit_tickets()){ ?>
							<tr>
								<th>
									<?php _e('Public link', 'wpetss');?>
								</th>
								<td>
                                    <a href="<?php echo module_ticket::link_public($ticket_id);?>" target="_blank">click here</a>
								</td>
							</tr>
                            <?php } ?>
						</tbody>
					</table>

                    <p align="center">
                    <?php if(module_ticket::can_edit_tickets()){ ?>
                    <input type="submit" name="butt_save" id="butt_save" value="<?php echo __('Save details', 'wpetss'); ?>" class="submit_button save_button" />
                    <?php } ?>
					<?php if((int)$ticket_id && module_ticket::can_edit_tickets()){ ?>
					<input type="submit" name="butt_del" id="butt_del" onclick="return confirm('Really delete?');" value="<?php echo __('Delete', 'wpetss'); ?>" class="submit_button delete_button" />
					<?php } ?>
					<input type="button" name="cancel" value="<?php echo __('Cancel', 'wpetss'); ?>" onclick="window.location.href='<?php echo is_user_logged_in() ? get_admin_url().'admin.php?page=wpetss-dashboard' : get_home_url();?>';" class="submit_button" />
                    </p>
                    <?php if((int)$ticket_id && module_ticket::can_edit_tickets()){ ?>
                    <p align="center">
                        <input type="submit" name="mark_as_unread" value="<?php echo __('Mark as unread', 'wpetss'); ?>" class="submit_button" />
                    </p>
                    <?php } ?>

				</td>
                <td valign="top" style="padding:10px;">
                    <h3><?php echo __('Ticket Messages', 'wpetss'); ?></h3>
                    <div id="ticket_container" style="<?php echo get_option('ticket_scroll',0) ? ' max-height: 400px; overflow-y:auto;' : '';?>">
                        <?php
                        $ticket_messages = module_ticket::get_ticket_messages($ticket_id);
                        $reply__ine_default = module_ticket::$default_reply_above; // incase they change it
                        $reply__ine =  get_option('ticket_reply_line',module_ticket::$default_reply_above);
                        foreach($ticket_messages as $ticket_message){
                            $cache = unserialize($ticket_message['cache']);
                            $attachments = module_ticket::get_ticket_message_attachments($ticket_message['ticket_message_id']);
                            ?>
                            <div class="ticket_message ticket_message_<?php echo $ticket['user_id'] == $ticket_message['from_user_id'] ? 'creator' : 'admin';?>">
                                <div class="ticket_message_title">
                                    <div class="ticket_message_title_summary">
                                        <strong><?php
                                            if($logged_in_user == $ticket_message['from_user_id']){
                                                // this message was from me !
                                                echo __('Me:', 'wpetss');
                                            }else{
                                               // this message was from someone else.
                                                // eg, the Customer, or the Response from admin.
                                                if($ticket['user_id'] == $ticket_message['from_user_id']){
                                                    echo __('Customer:', 'wpetss');
                                                }else{
                                                    echo __('Support:', 'wpetss');
                                                }
                                            }
                                            ?></strong>
                                        <?php echo date(get_option('date_format','Y-m-d'),($ticket_message['message_time'])); ?>
                                        <a href="#" onclick="jQuery(this).parent().hide(); jQuery(this).parent().parent().find('.ticket_message_title_full').show(); return false;"><?php echo __('more &raquo;', 'wpetss');?></a>
                                    </div>
                                    <div class="ticket_message_title_full">

                                        <span>
                                            <?php _e('Date:', 'wpetss');?> <strong>
                          <?php echo date(get_option('date_format','Y-m-d').' '.get_option('time_format','H:i:s'),($ticket_message['message_time'])); ?></strong>
                                        </span>
                                        <span>
                                            <?php _e('From:', 'wpetss');?> <strong><?php echo htmlspecialchars($ticket_message['from_name']);?> &lt;<?php echo htmlspecialchars($ticket_message['from_email']);?>&gt;</strong>
                                        </span>
                                        <span>
                                            <?php _e('To:', 'wpetss');?> <strong><?php echo htmlspecialchars($ticket_message['to_name']);?> &lt;<?php echo htmlspecialchars($ticket_message['to_email']);?>&gt;</strong>
                                        </span>
                                        <br/>
                                    </div>
                                        <?php

                                        // todo
                                        if(count($attachments)){
                                            echo '<span>';
                                            _e('Attachments:', 'wpetss');
                                            foreach($attachments as $attachment){
                                                ?>
                                                <a href="?_wpetss_process=download_attachment&ticket_id=<?php echo $ticket_id;?>&attach_id=<?php echo $attachment['ticket_message_attachment_id'];?>&hash=<?php echo md5($attachment['ticket_message_attachment_id'].' secrertz ' .$ticket_id . SECURE_AUTH_KEY); ?>"><?php echo htmlspecialchars($attachment['file_name']);?> (<?php echo wpetss_frndlyfilesize(filesize(_TMP_DIR.'attach-'.$ticket_id.'-'.$attachment['ticket_message_attachment_id']));?>)</a>
                                                <?php
                                            }
                                            echo '</span>';
                                        }
                                        ?>
                                </div>
                                <div class="ticket_message_text">
                                    <?php //echo nl2br(htmlspecialchars($ticket_message['content'])); ?>
                                    <?php
                                    $text = wpetss_forum_text(utf8_encode($ticket_message['content']));
                                    if(true){
                                        $lines = explode("\n",$text);
                                        $hide__ines = $print__ines = array();
                                        foreach($lines as $line_number => $line){
                                            // hide anything after
                                            $line = trim($line);
                                            if(
                                                count($hide__ines) ||
                                                preg_match('#'.preg_quote($reply__ine,'#').'.*$#ims',$line) ||
                                                preg_match('#'.preg_quote($reply__ine_default,'#').'.*$#ims',$line)
                                            ){
                                                if(!count($hide__ines)){
                                                    // move the line before if it exists.
                                                    if(isset($print__ines[$line_number-1])){
                                                        if(trim(preg_replace('#<br[^>]*>#i','',$print__ines[$line_number-1]))){
                                                            $hide__ines[$line_number-1] = $print__ines[$line_number-1];
                                                        }
                                                        unset($print__ines[$line_number-1]);
                                                    }
                                                    // move the line before if it exists.
                                                    if(isset($print__ines[$line_number-2])){
                                                        if(trim(preg_replace('#<br[^>]*>#i','',$print__ines[$line_number-2]))){
                                                            $hide__ines[$line_number-2] = $print__ines[$line_number-2];
                                                        }
                                                        unset($print__ines[$line_number-2]);
                                                    }
                                                    // move the line before if it exists.
                                                    if(isset($print__ines[$line_number-3]) && preg_match('#^On #',trim($print__ines[$line_number-3]))){
                                                        if(trim(preg_replace('#<br[^>]*>#i','',$print__ines[$line_number-3]))){
                                                            $hide__ines[$line_number-3] = $print__ines[$line_number-3];
                                                        }
                                                        unset($print__ines[$line_number-3]);
                                                    }
                                                }
                                                $hide__ines [$line_number] = $line;
                                                unset($print__ines[$line_number]);
                                            }else{
                                                // not hidden yet.
                                                $print__ines[$line_number] = $line;
                                            }
                                        }
                                        ksort($hide__ines);
                                        ksort($print__ines);
                                        echo implode("\n",$print__ines);
                                        //print_r($print__ines);
                                        if(count($hide__ines)){
                                            echo '<a href="#" onclick="jQuery(this).parent().find(\'div\').toggle(); return false;">'.__('- show quoted text -', 'wpetss').'</a> ';
                                            echo '<div style="display:none;">';
                                            echo implode("\n",$hide__ines);
                                            echo '</div>';
                                            //print_r($hide__ines);
                                        }
                                    }else{
                                        echo $text;
                                    }
                                    ?>
                                </div>
                            </div>
                        <?php } ?>


                        <?php
                        if($logged_in_user || is_user_logged_in()){
                        ?>

                        <?php if(count($ticket_messages)){ ?>
                        <div id="ticket_reply_button">
                            <input type="button" name="reply" onclick="jQuery('#ticket_reply_button').hide(); jQuery('#ticket_reply_holder').show(); jQuery('#new_ticket_message')[0].focus(); return false;" value="<?php echo __('Reply to ticket', 'wpetss');?>">
                        </div>
                        <div style="display: none;" class="ticket_reply" id="ticket_reply_holder">
                        <?php }else{ ?>
                        <div id="ticket_reply_holder" class="ticket_reply">
                        <?php } ?>

                            <div class="ticket_message ticket_message_<?php echo $ticket['user_id'] == $logged_in_user ? 'creator' : 'admin';?>">
                                <div class="ticket_message_title" style="text-align: left;">
                                    <strong><?php echo __('Enter Your Message:', 'wpetss');?></strong>
                                </div>
                                <div class="ticket_message_text">

                                    <textarea rows="6" cols="20" name="new_ticket_message" id="new_ticket_message"></textarea>
                                    <div style="line-height: 25px; padding:10px;">
                                        <?php _e('Attachments', 'wpetss');?>
                                        <input type="file" name="attachment[]">
                                    </div>
                                    <div style="line-height: 25px; padding:10px;">
                                    <?php if(module_ticket::can_edit_tickets()){ ?>
                                        <?php _e('Change ticket status:', 'wpetss');
                                        echo ' ';
                                        $current_status = $ticket['status_id'];
                                            if(count($ticket_messages)){
                                            if($current_status <= 2){
                                                $current_status = 3; // change to replied
                                            }else{
                                                $current_status = 5; // change to in progress
                                            }
                                        }
                                        echo wpetss_print_select_box(module_ticket::get_statuses(),'change_status_id',$current_status);
                                        ?>
                                        <br/>
                                    <?php } ?>
                                        <input type="hidden" name="creator_id" value="<?php echo $logged_in_user;?>">
                                                <input type="hidden" name="creator_hash" value="<?php echo module_ticket::creator_hash($logged_in_user);?>">
                                            <?php _e('Send message as:', 'wpetss');?>
                                            <strong>
                                                <?php echo htmlspecialchars($send_as_name);?>
                                                &lt;<?php echo htmlspecialchars($send_as_address);?>&gt;
                                            </strong>
                                            <!-- <?php _e('Reply To:', 'wpetss');?> <strong><?php echo htmlspecialchars($to_user_a['email']);?></strong> -->
                                        <br/>
                                        <input type="submit" name="newmsg" value="<?php _e('Send Reply Message', 'wpetss');?>" class="submit_button save_button">
                                    </div>
                                </div>
                            </div>
                        </div>
                        <?php } ?>
                    </div>
                </td>
			</tr>
			<tr>
				<td align="center" colspan="2">

				</td>
			</tr>
		</tbody>
	</table>

</form>

</div>