<?php

//todo: init the user table with userid 1 from the wp blog

/*
	Plugin Name: WordPress (Simple) Email Ticket Support System
	Plugin URI: http://dtbaker.com.au/
	Description: Allow a customer to request ticketted support via WordPress blog
	Version: 1.0
	Author:  David Baker
	Author URI: http://dtbaker.com.au
    Support: For all support please use http://codecanyon.net/user/dtbaker
	License: Please purchase a license for this item at CodeCanyon.net
    Date: May 30th 2011
    Text Domain: wpetss
*/

// if (version_compare(PHP_VERSION, '5.0.0', '<') ) exit("Sorry, this version of PHPMailer will only run on PHP version 5 or greater!\n");

define('_TMP_DIR',plugin_dir_path(__FILE__).'temp/');
if((!is_dir(_TMP_DIR) || !is_writable(_TMP_DIR)) && current_user_can('manage_options')){
	echo 'Please make sure the folder "'.plugin_dir_url(__FILE__).'temp/'.'" has PHP write permissions. Please delete this plugin and install it via WordPress upload zip feature.';
	exit;
}


add_action('init','wpetss_session');
add_action('admin_menu', 'wpetss_menu');
add_action('wp_before_admin_bar_render', 'wpetss_menu_bar');
add_action('wp_head', 'wpetss_head');
add_action('admin_head', 'wpetss_head');

if(!load_plugin_textdomain('wpetss','/wp-content/languages/')){
    load_plugin_textdomain('wpetss',plugin_dir_path(__FILE__).'i8n/');
}

require_once 'includes/config.php';
require_once 'includes/functions.php';
require_once 'includes/ticket.php';
require_once 'includes/form.php';
require_once 'includes/database.php';
require_once 'includes/envato.php';
require_once('wpetss_widgets.php');
require_once('wpetss_shortcodes.php');

module_ticket::init();

function wpetss_head(){
    global $wpdb;
    $page_id = get_the_ID();
    //if ( current_user_can('manage_options') ){
    //if ( is_user_logged_in() ){
    ?>
    <script type="text/javascript">
        if(typeof dtbaker_wpetss != undefined){
            dtbaker_wpetss.popup_url = '<?php echo plugin_dir_url(__FILE__).'ajax.php';?>';
        }
    </script>
       
            
    <?php
    //}
    
    if(isset($_REQUEST['wpetss']) && $_REQUEST['wpetss'] == 'public'){

        $ticket_id = (int)$_REQUEST['i'];
        $hash = $_REQUEST['hash'];
        $real_hash = module_ticket::link_public($ticket_id,true);
        if($hash == $real_hash){
        ?>


        <script type="text/javascript">
            jQuery(function(){
                if(typeof dtbaker_wpetss != undefined){
                    dtbaker_wpetss.edit('<?php echo $ticket_id;?>');
                }
            });
        </script>

    <?php }
        }
}

function wpetss_stripslashes_deep($array){
    foreach($array as $key=>$val){
        if(is_array($val)){
            $array[$key] = wpetss_stripslashes_deep($val);
        }else{
            $array[$key] = stripslashes($val);
        }
    }
    return $array;
}

function wpetss_session(){

    
    // only add this script if the user has permissions to add / edit sticky notes.
    wp_register_script( 'wpetss', plugin_dir_url(__FILE__).'javascript.js');
    wp_register_script( 'wpetss_fancybox', plugin_dir_url(__FILE__).'fancybox1.3.4/jquery.fancybox-1.3.4.js');
    wp_register_style( 'wpetss', plugin_dir_url(__FILE__).'wpetss.css');
    wp_register_style( 'wpetss_fancybox', plugin_dir_url(__FILE__).'fancybox1.3.4/jquery.fancybox-1.3.4.css');
    
    wp_enqueue_script( 'jquery' );
    wp_enqueue_script( 'wpetss_fancybox' );
    wp_enqueue_script( 'wpetss' );
    wp_enqueue_style( 'wpetss' );
    wp_enqueue_style( 'wpetss_fancybox' );

    if(module_ticket::can_edit_tickets() && isset($_GET['ticket_id']) && isset($_REQUEST['view'])){
        // hack to remove the 'pending' count straight away.
        module_ticket::mark_as_read($_GET['ticket_id']);
    }

    if(isset($_REQUEST['_wpetss_process'])){
        $_POST = wpetss_stripslashes_deep($_POST);
        $_GET = wpetss_stripslashes_deep($_GET);
        $_REQUEST = $_GET + $_POST;
        $ticket_id = isset($_REQUEST['ticket_id']) ? (int)$_REQUEST['ticket_id'] : false;
        switch($_REQUEST['_wpetss_process']){
            case 'download_attachment':
                $attach_id = (int)$_REQUEST['attach_id'];
                $hash = $_REQUEST['hash'];
                $real_hash = md5($attach_id.' secrertz ' .$ticket_id . SECURE_AUTH_KEY);
                if($attach_id > 0 && $hash == $real_hash){
                    $attach = wpetss_get_single('wpetss_ticket_message_attachment','ticket_message_attachment_id',$attach_id);
                    header("Content-type: application/octet-stream");
                    header('Content-Disposition: attachment; filename="'.$attach['file_name'].'";');
                    readfile(_TMP_DIR.'attach-'.$attach['ticket_id'].'-'.$attach['ticket_message_attachment_id']);
                    exit;
                }
                break;
            case 'save_ticket_account':
                if(module_ticket::can_edit_tickets()){
                    $ticket_account_id = wpetss_update_insert('ticket_account_id',$_REQUEST['ticket_account_id'],'wpetss_ticket_account',$_POST);
                    if(module_ticket::check_ticket_account($ticket_account_id)){
                        header("Location: admin.php?page=wpetss-accounts&ticket_account_id=$ticket_account_id&msg=2");
                        exit;
                    }else{
                        echo 'Error checking account. Please confirm POP3 details with your email hosting provider. ';
                        echo 'Please confirm with your hosting provider that emails can be checked via POP3 using PHP ';
                        exit;
                    }
                }
                break;
            case 'save_ticket':

                if(isset($_REQUEST['dtbakerss']) && $_REQUEST['dtbakerss'] == 'true'){
                    echo 'Spam Blocked, please try again.';
                    exit;
                }

                if(module_ticket::can_edit_tickets() && isset($_REQUEST['butt_del']) && $_REQUEST['butt_del']){
                    module_ticket::delete_ticket($ticket_id);
                    header("Location: admin.php?page=wpetss-dashboard&msg=2");
                    exit;
                }
                $ticket_id = module_ticket::save_ticket($ticket_id,$_POST);
                if(module_ticket::can_edit_tickets() && isset($_REQUEST['mark_as_unread']) && $_REQUEST['mark_as_unread']){
                    module_ticket::mark_as_unread($ticket_id);
                    header("Location: ".get_admin_url()."admin.php?page=wpetss-dashboard&msg=1&ticket_id=$ticket_id");
                    exit;
                }else if(isset($_REQUEST['from_public']) || !module_ticket::can_edit_tickets()){
                    // redirect to a nice page after ticket submission.
                    $redirect = get_option('ticket_redirect',get_home_url());
                    header("Location: $redirect");
                    exit;
                }else{
                    header("Location: ".get_admin_url()."admin.php?page=wpetss-dashboard&msg=1&ticket_id=$ticket_id");
                    exit;
                }
                break;
        }
    }
}

function wpetss_menu_bar(){
    // setup the hook in the top menu area.
    global $wp_admin_bar, $wpdb;

    if ( current_user_can('manage_options') ){
        $flag = '';
        $table_name = $wpdb->prefix . "wpetss_ticket";
        $tickets = $wpdb->get_results("SELECT * FROM $table_name
            WHERE unread = 1");
        // if we are an administrator we display the total number of unread tickets
        if(count($tickets)>0){
            $flag = "<span id='ab-awaiting-mod' class='pending-count'>".count($tickets)." pending</span>";
        }
        $wp_admin_bar->add_menu( array(
                                      'id' => 'wpetss_admin_top',
                                      'title' => sprintf(__( 'Support Tickets %s' , 'wpetss'),$flag),
                                      'href' => get_admin_url(null,'admin.php?page=wpetss-dashboard'),
                                 )
        );
        $wp_admin_bar->add_menu( array(
                                      'parent' => 'wpetss_admin_top',
                                      'id' => 'wpetss_admin_top1',
                                      'title' => __( 'View all tickets' , 'wpetss'),
                                      'href' => get_admin_url(null,'admin.php?page=wpetss-dashboard'),
                                 )
        );
        $wp_admin_bar->add_menu( array(
                                      'parent' => 'wpetss_admin_top',
                                      'id' => 'wpetss_admin_top2',
                                      'title' => sprintf(__( 'Create new ticket %s' , 'wpetss'),'<span class="wpetss_open"></span>'),
                                      'href' => '#',
                                 )
        );
    }else{
        // if we are an end user we display links allowing them to request tickets.
        $flag = '';
        //$flag = "<span id='ab-awaiting-mod' class='pending-count'>2 remain</span>";
        $wp_admin_bar->add_menu( array(
                                      'id' => 'wpetss_user_top',
                                      'title' => sprintf(__( 'Create new ticket %s' , 'wpetss'),'<span class="wpetss_open"></span>'),
                                      'href' => '#',
                                 )
        );
    }
}
function wpetss_menu() {
    // todo: work out the user permissions as set by the administrator, which users can see which menu items.
	if(current_user_can('manage_options')){
        // pending count:
        global $wpdb;
        $flag = '';
        $table_name = $wpdb->prefix . "wpetss_ticket";
        $tickets = $wpdb->get_results("SELECT * FROM $table_name
            WHERE unread = 1");
        // if we are an administrator we display the total number of unread tickets
        if(count($tickets)>0){
            $flag = '<span id="awaiting-mod" class="count-1"><span class="pending-count">'.count($tickets)."</span></span>";
        }
		add_menu_page('Tickets', sprintf('Tickets %s',$flag), 'manage_options', 'wpetss-dashboard', 'wpetss_menu_init', plugin_dir_url(__FILE__).'images/ticket.png');
        add_submenu_page('wpetss-dashboard', "Settings", "Settings", 1, 'wpetss-settings', 'wpetss_menu_init');
        add_submenu_page('wpetss-dashboard', "POP3 Accounts", "POP3 Accounts", 1, 'wpetss-accounts', 'wpetss_menu_init');
        //add_submenu_page('wpetss-dashboard', "Envato", "Envato", 1, 'wpetss-envato', 'wpetss_menu_init');
	}else{
		add_menu_page('Tickets', 'Tickets', 'read', 'wpetss-dashboard', 'wpetss_menu_init', plugin_dir_url(__FILE__).'images/ticket.png');
	}
    add_submenu_page('wpetss-dashboard', "Create Ticket", "Create Ticket", 0, 'wpetss-create-ticket', 'wpetss_menu_init');
    if(isset($_GET['ticket_id']) && (int)$_GET['ticket_id']>0){
        add_submenu_page('wpetss-dashboard', "Edit Ticket", "Edit Ticket", 0, 'wpetss-edit-ticket', 'wpetss_menu_init');
    }
}

function wpetss_menu_init(){
    $page = isset($_REQUEST['page']) ? $_REQUEST['page'] : 'wpetss-dashboard';
    switch($page){
        case 'wpetss-create-ticket';
        case 'wpetss-edit-ticket';
            wpetss_menu_edit();
            break;
        case 'wpetss-settings':
            wpetss_menu_settings();
            break;
        case 'wpetss-accounts':
            wpetss_account_settings();
            break;
        case 'wpetss-dashboard':
        default:
            wpetss_menu_dashboard();
            break;
    }
}

function wpetss_menu_edit($options=array()) {

    if(isset($options['layout'])){
        $layout = $options['layout'];
    }else{
        $layout = 'two_columns';
    }
    $ticket_id = (isset($_REQUEST['ticket_id'])) ? (int)$_REQUEST['ticket_id'] : 0;
    $ticket = array();


    if(!isset($ticket_id)){
        $ticket_id = isset($_REQUEST['ticket_id']) ? (int)$_REQUEST['ticket_id'] : 0;
    }

    if(!isset($ticket) || !$ticket){
        $ticket = module_ticket::get_ticket($ticket_id);
    }

    if((int)$ticket_id>0 && module_ticket::can_edit_tickets()){
        module_ticket::mark_as_read($ticket_id);
    }

    // work out which account this is from.
    if(isset($ticket) && isset($ticket['ticket_account_id'])){
        $ticket_account_id = (int)$ticket['ticket_account_id'];
    }else if(isset($_REQUEST['tac']) && $_REQUEST['tac']){
        $ticket_account_id = (int)$_REQUEST['tac'];
    }else{
        // pick the first available / default ticket account.
        $ticket_account_id = get_option('ticket_default_account',1);
    }

    $ticket_account = array();
    if((int)$ticket_account_id > 0){
        $ticket_account = module_ticket::get_ticket_account($ticket_account_id);
        if(!$ticket_account){
            $ticket_account_id = 0;
        }
    }
    if(!$ticket['ticket_account_id'] && $ticket_account_id){
        $ticket['ticket_account_id'] = $ticket_account_id;
    }


    if(!is_user_logged_in() && !$ticket_id){
        include('layouts/ticket_public.php');
    }else{
        include('layouts/ticket_edit.php');
    }




}
function wpetss_menu_settings() {

	if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.', 'wpetss') );
}   
    $_POST = wpetss_stripslashes_deep($_POST);
    $_GET = wpetss_stripslashes_deep($_GET);
    $_REQUEST = $_GET + $_POST;
    if(isset($_REQUEST['save'])){
        foreach($_POST as $key=>$val){
            if(strpos($key,'wpetss_setting_')!==false){
                update_option(str_replace('wpetss_setting_','',$key),$val);
            }
        }
    }
    $plugin_dir = plugin_dir_path(__FILE__);
    $plugin_url = plugin_dir_url(__FILE__);
	include('layouts/settings.php');

}
function wpetss_account_settings() {

	if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.', 'wpetss') );
	}
	include('layouts/accounts.php');

}
function wpetss_menu_dashboard() {



    $search = isset($_REQUEST['wpetss_search'])&&is_array($_REQUEST['wpetss_search']) ? $_REQUEST['wpetss_search'] : array();


    $search_statuses = module_ticket::get_statuses();
    $search_statuses['2,3,5'] = __('New/Replied/In Progress', 'wpetss');
    if(!isset($search['status_id'])){
        $search['status_id'] = '2,3,5';
    }

    if (current_user_can('manage_options'))  {
        // show all.
    }else{
        // show all tickets that are owned by this wordpress user.
        $user_id = get_current_user_id();
        $user_id = module_ticket::user_from_wp_id($user_id);
        $search['user_id'] = $user_id;
        // look up this wp_user_id in the wpetss_ticket_user table
        // find it's ticket user_id and use that one.
    }

    
    $alltickets = module_ticket::get_tickets($search);

    $pagination = wpetss_process_pagination($alltickets,get_option('ticket_per_page',15));


    $plugin_url = plugin_dir_url(__FILE__);

    include('layouts/ticket_list.php');

}

function wpetss_dashboard_widget() {

    include('layouts/dashboard.php');

}

// Create the function use in the action hook

function wpetss_dashboard_widget_setup() {
    if(module_ticket::can_edit_tickets()){
        $alltickets = module_ticket::get_tickets(array('status_id'=>'2,3,5'));
        $m = count($alltickets);
        $c = min(get_option('ticket_dashboard_limit',3),$m);
        $title = sprintf(__('Open Ticket Requests (displaying %s of %s)', 'wpetss'),$c,$m);
        wp_add_dashboard_widget('wpetss_dashboard_widget', $title, 'wpetss_dashboard_widget');
    }
}

// Hook into the 'wp_dashboard_setup' action to register our other functions

add_action('wp_dashboard_setup', 'wpetss_dashboard_widget_setup' );




/** DATABSE STUFF  **/
global $wpetss_db_version;
$wpetss_db_version = "1.0";

function wpetss_install () {
    global $wpdb;
    global $wpetss_db_version;

    

    $table_name = $wpdb->prefix . "wpetss_ticket";
    if($wpdb->get_var("show tables like '$table_name'") != $table_name) {

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $sql = "CREATE TABLE " . $table_name . " (
        `ticket_id` mediumint(9) NOT NULL AUTO_INCREMENT,
          `ticket_account_id` int(11) NOT NULL,
          `customer_id` int(11) DEFAULT NULL,
          `website_id` int(11) DEFAULT NULL,
          `user_id` int(11) NOT NULL,
          `assigned_user_id` int(11) NOT NULL,
          `last_message_timestamp` int(11) NOT NULL,
          `status_id` int(11) NOT NULL,
          `subject` varchar(255) NOT NULL DEFAULT '',
          `type` varchar(255) NOT NULL DEFAULT '',
          `unread` tinyint(1) NOT NULL DEFAULT '1',
          `date_completed` date NOT NULL,
          `date_created` datetime NOT NULL,
          `date_updated` datetime NOT NULL,
        PRIMARY KEY ticket_id (ticket_id)
        );";
        dbDelta($sql);
        add_option("wpetss_db_version", $wpetss_db_version);
    }

    $table_name_alt = $table_name . '_account';
    if($wpdb->get_var("show tables like '$table_name_alt'") != $table_name_alt) {

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $sql = "CREATE TABLE " . $table_name_alt . " (
          `ticket_account_id` int(11) NOT NULL AUTO_INCREMENT,
          `name` varchar(255) NOT NULL,
          `email` varchar(255) NOT NULL,
          `username` varchar(255) NOT NULL,
          `password` varchar(255) NOT NULL,
          `host` varchar(255) NOT NULL,
          `port` int(11) NOT NULL DEFAULT '110',
          `delete` tinyint(4) NOT NULL DEFAULT '0',
          `default_user_id` int(11) NOT NULL DEFAULT '0',
          `default_customer_id` int(11) NOT NULL DEFAULT '0',
          `default_type` varchar(255) NOT NULL,
          `subject_regex` varchar(255) NOT NULL,
          `body_regex` varchar(255) NOT NULL,
          `to_regex` varchar(255) NOT NULL,
          `start_date` date NOT NULL,
          `last_checked` int(11) NOT NULL DEFAULT '0',
          `date_created` date NOT NULL,
          `date_updated` date NOT NULL,
        PRIMARY KEY ticket_account_id (ticket_account_id)
        );";
        dbDelta($sql);
    }
    $table_name_alt = $table_name . '_envato';
    if($wpdb->get_var("show tables like '$table_name_alt'") != $table_name_alt) {

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $sql = "CREATE TABLE " . $table_name_alt . " (
          `ticket_envato_id` int(11) NOT NULL AUTO_INCREMENT,
          `username` varchar(255) NOT NULL,
          `password` varchar(255) NOT NULL,
          `api_key` varchar(255) NULL,
          `item_list` text NULL,
          `date_created` date NOT NULL,
          `date_updated` date NOT NULL,
        PRIMARY KEY ticket_envato_id (ticket_envato_id)
        );";
        dbDelta($sql);
    }

    $table_name_alt = $table_name . '_faq';
    if($wpdb->get_var("show tables like '$table_name_alt'") != $table_name_alt) {

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $sql = "CREATE TABLE " . $table_name_alt . " (
          `ticket_faq_id` int(11) NOT NULL AUTO_INCREMENT,
          `title` varchar(255) NOT NULL,
          `content` text NOT NULL,
          `date_created` date NOT NULL,
          `date_updated` date NOT NULL,
        PRIMARY KEY ticket_envato_id (ticket_envato_id)
        );";
        dbDelta($sql);
    }

    $table_name_alt = $table_name . '_envato_user';
    if($wpdb->get_var("show tables like '$table_name_alt'") != $table_name_alt) {

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $sql = "CREATE TABLE " . $table_name_alt . " (
          `ticket_envato_user_id` int(11) NOT NULL AUTO_INCREMENT,
          `username` varchar(255) NOT NULL,
          `purchase_history` text NULL,
          `ticket_user_id` int(11) NULL,
          `date_created` date NOT NULL,
          `date_updated` date NOT NULL,
        PRIMARY KEY ticket_envato_user_id (ticket_envato_user_id)
        );";
        dbDelta($sql);
    }

    $table_name_alt = $table_name . '_message';
    if($wpdb->get_var("show tables like '$table_name_alt'") != $table_name_alt) {

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $sql = "CREATE TABLE " . $table_name_alt . " (
          `ticket_message_id` int(11) NOT NULL AUTO_INCREMENT,
          `ticket_id` int(11) DEFAULT NULL,
          `message_id` varchar(255) NOT NULL,
          `content` text NOT NULL,
          `htmlcontent` text NOT NULL,
          `message_time` int(11) NOT NULL,
          `message_type_id` int(11) NOT NULL,
          `from_user_id` int(11) NOT NULL,
          `to_user_id` int(11) NOT NULL,
          `cache` text NOT NULL,
          `status_id` int(11) NOT NULL,
          `date_created` date NOT NULL,
          `date_updated` date NOT NULL,
        PRIMARY KEY ticket_message_id (ticket_message_id)
        );";
        dbDelta($sql);
    }
    $table_name_alt = $table_name . '_user';
    if($wpdb->get_var("show tables like '$table_name_alt'") != $table_name_alt) {

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $sql = "CREATE TABLE " . $table_name_alt . " (
          `user_id` int(11) NOT NULL AUTO_INCREMENT,
          `name` varchar(255) NOT NULL,
          `email` varchar(255) NOT NULL,
          `wp_user_id` int(11) NOT NULL,
          `date_created` date NOT NULL,
          `date_updated` date NOT NULL,
        PRIMARY KEY user_id (user_id)
        );";
        dbDelta($sql);
    }

    $table_name_alt = $table_name . '_message_attachment';
    if($wpdb->get_var("show tables like '$table_name_alt'") != $table_name_alt) {

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $sql = "CREATE TABLE " . $table_name_alt . " (
          `ticket_message_attachment_id` int(11) NOT NULL AUTO_INCREMENT,
          `ticket_id` int(11) DEFAULT NULL,
          `ticket_message_id` int(11) DEFAULT NULL,
          `file_name` varchar(255) NOT NULL,
          `content_type` varchar(60) NOT NULL,
          `date_created` date NOT NULL,
          `date_updated` date NOT NULL,
        PRIMARY KEY ticket_message_attachment_id (ticket_message_attachment_id)
        );";
        dbDelta($sql);
    }

	//wp_schedule_event(time(), 'twominutes', 'wpetss_wp_cron');
        
}
register_activation_hook(__FILE__,'wpetss_install');

/*
add_action('wpetss_minute_event', 'wpetss_cron');
add_action('cron_schedules', 'wpetss_cron_schedule');

function wpetss_cron() {
	module_ticket::check_all_accounts();
}
function wpetss_cron_schedule($array) {
	return array(
		'twominutes' => array( 'interval' => 120, 'display' => __('Two Minutes', 'wpetss') ),
    );
}

register_deactivation_hook(__FILE__, 'wpetss_deactivation');

function wpetss_deactivation() {
	wp_clear_scheduled_hook('wpetss_wp_cron');
}
*/