<?php


class wpetsswidget_request extends WP_Widget {
    /** constructor */
    function wpetsswidget_request() {
		$widget_ops = array( 'description' => __('Use this widget to allow public users ticket request ability.', 'wpetss') );
		parent::WP_Widget(false, __('Submit Support Ticket', 'wpetss'), $widget_ops );
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {

        extract( $args );
        $title = apply_filters('widget_title', $instance['title']);
        $button_name = $instance['button_name'];
        $description = $instance['description'];
        $ticket_account_id = (int)$instance['ticket_account_id'];

        ?>
		  <?php echo $before_widget; ?>
        <div class="wpetss_widget">
                <?php
                if ( $title ){
                    echo $before_title . $title . $after_title;
                }
                ?>
            <div class="wpetss_widget_button">
                    <input type="button" id="wpetss_create" onclick="dtbaker_wpetss.launch_popup(<?php echo $ticket_account_id;?>);" value="<?php echo esc_attr($button_name);?>" name="create_ticket"/>
                </div>
            <div class="wpetss_widget_description">
                    <?php echo $description; ?>
                </div>
        </div>
		  <?php echo $after_widget; ?>
        <?php
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['button_name'] = strip_tags($new_instance['button_name']);
		$instance['description'] = strip_tags($new_instance['description']);
		$instance['ticket_account_id'] = (int)$new_instance['ticket_account_id'];
        return $instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {
        $title = esc_attr($instance['title']);
		if(!$title)$title = 'Submit Support Ticket';
        $button_name = esc_attr($instance['button_name']);
		if(!$button_name)$button_name = 'Submit Ticket';
        $description = esc_attr($instance['description']);
        if(!$description)$description = 'Please click this button to submit a support ticket.';
        $ticket_account_id = esc_attr($instance['ticket_account_id']);
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'wpetss'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('button_name'); ?>"><?php _e('Button Text:', 'wpetss'); ?> <input class="widefat" id="<?php echo $this->get_field_id('button_name'); ?>" name="<?php echo $this->get_field_name('button_name'); ?>" type="text" value="<?php echo $button_name; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('description'); ?>"><?php _e('Description:', 'wpetss'); ?> <input class="widefat" id="<?php echo $this->get_field_id('description'); ?>" name="<?php echo $this->get_field_name('description'); ?>" type="text" value="<?php echo $description; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('ticket_account_id'); ?>"><?php _e('(optional) Linked POP3 Account:', 'wpetss'); ?>
                <select class="widefat" name="<?php echo $this->get_field_name('ticket_account_id'); ?>">
                    <option value=""><?php _e(' - select - ', 'wpetss');?></option>
                    <?php foreach(module_ticket::get_ticket_accounts() as $account){ ?>
                        <option value="<?php echo $account['ticket_account_id'];?>"<?php echo $account['ticket_account_id'] == $ticket_account_id ? ' selected' : '';?>><?php echo $account['name'];?></option>
                    <?php } ?>
                </select> </label>
            <br/>
            <small><em>Assign web tickets to this account. Just means the POP3 account details are applied to these web tickets. Optional setting.</em></small></p>
        <?php
    }

} // class wpetsswidget_latest

add_action('widgets_init', create_function('', 'return register_widget("wpetsswidget_request");'));

